program extract;
{$APPTYPE CONSOLE}
uses
  SysUtils, Classes;

// Recursive procedure to build a list of files
// from: http://www.festra.com/eng/snip04.htm
procedure FindFiles(FilesList: TStringList; StartDir, FileMask: string);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if StartDir[length(StartDir)] <> '\' then
    StartDir := StartDir + '\';

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound :=
    FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR) = 0;
  while IsFound do begin
    FilesList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0
  end;
  FindClose(SR);

  // Build a list of subdirectories
  DirList := TStringList.Create;
  IsFound := FindFirst(StartDir+'*.*', faAnyFile, SR) = 0;
  while IsFound do begin
    if ((SR.Attr and faDirectory) <> 0) and
         (SR.Name[1] <> '.') then
      DirList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0
  end;
  FindClose(SR);

  // Scan the list of subdirectories
  for i := 0 to DirList.Count - 1 do
    FindFiles(FilesList, DirList[i], FileMask);

  DirList.Free
end;

// T_INV        // an invalid token
// T_NA         // an invalid token
// T_CMD        // a command
// T_OPER       // an operator
// T_FUN        // a function (also used for a function that can operate as a command)
// T_FNA        // a function that has no arguments
//

var
  FilesList: TStringList;

var T:text;
    I,B,C,D:integer;
    ch:char;
    matched:boolean;
    S:string;

begin
  FilesList:=TStringList.Create;
  try
    FindFiles(FilesList,'..\Source','*.h');

    for I:=0 to FilesList.Count-1 do
    begin
      assignfile(T,FilesList.Strings[I]);
      reset(T);
      matched:=false;
      while not eof(T) do
      begin
        S:='';
        repeat
          read(T,ch);
          if not (ch in [#10,#13]) then S:=S+ch;
        until eof(T) or (ch in [#10,#13]);

        B:=pos('{',S);
        C:=pos('}',s);
        D:=pos('T_INV',S)+pos('T_NA',S)+
           pos('T_CMD',S)+pos('T_OPER',S)+
           pos('T_FUN',S)+pos('T_FNA',S);

        if ((B*C)<>0) and (B<C) and (D<>0) then
        begin
          if not matched then
          begin
            writeln('extracted from ',FilesList.Strings[I]);
            matched:=true
          end;
          writeln(S)
        end
      end;
      if matched then writeln;
      close(T)
    end
  finally
    FilesList.Free
  end
end.
